//Accessing Method
`define BYTE_ACCESS 0
`define WORD_ACCESS 1
`define LONG_ACCESS 2

//Left OUTPUT Selection for Register file
`define IR1L_SEL 0
`define IR1H_SEL 1
`define IR3H_SEL 2
`define SP_SEL   3

//Right OUTPUT Selection for Register file
//`define IR1L_SEL 0
`define IR0L_SEL 1
`define IR3L_SEL 2
//`define SP_SEL 3

//Write Address Selection for Register file
//`define IR1L_SEL 0
//`define IR0L_SEL 1
//`define IR3L_SEL 3
//`define IR3H_SEL 2
`define SP_SEL_W   4
`define IR1H_SEL_W 5

//input data Selection for Register file
`define  ALU_OUT_SEL 0
`define  EA_SEL 1


//Program Address Sel
`define NEXT_PC_SEL 0
//`define EA_SEL	1
`define MOUT_SEL    2
`define BCC_SEL     3

//EA left Sel
`define PC_SEL 0
`define ABS8_SEL 1
`define ABS16_23_SEL 2
`define ABS16_45_SEL 3
`define ABS24_2345_SEL 4
`define ABS24_4567_SEL 5
`define IR1H_SEL_EA 6
`define IR3H_SEL_EA 7
`define aa8_SEL 8
`define ALU_OUT_SEL_EA 9
`define MOUT_SEL_EA  10
`define ABS123 11
`define NEXT_PC_EA 12
`define NEXT_PC_EA2 13
`define INT_VECTOR 14
//EA right SEL
`define ZERO_SEL 0
`define DISP8_SEL 1
`define DISP16_23_SEL 2
`define DISP16_45_SEL 3
`define VAL_MINUS4_SEL 4
`define VAL_MINUS2_SEL 5
`define VAL_MINUS1_SEL 6
`define DISP24_567 7


//ALU left
`define RO_LEFT_SEL 2'b00
`define IR1_SEL 2'b01
`define IR23_SEL 2'b10
`define IR2345_SEL 2'b11

//ALU right
`define RO_RIGHT_SEL 4'b0000
`define VAL_0_SEL	4'b0001
`define VAL_1_SEL	4'b0010
`define VAL_2_SEL	4'b0011
`define VAL_4_SEL	4'b0100
`define VAL_MINUS1_SEL_ALU 4'b0101
`define VAL_MINUS2_SEL_ALU 4'b0110
`define VAL_MINUS4_SEL_ALU 4'b0111
`define MOUT_SEL_ALU	4'b1000
`define CCR_SEL   4'b1001
`define MUL_DIV_OUT_SEL 4'b1010

//ALU op
`define  BYPATH_RIGHT 5'b0_0000
`define  BYPATH_LEFT  5'b0_0001
`define  ADD		  5'b0_0010
`define  SUB	      5'b0_0011
`define  ADDX         5'b0_0100
`define  SUBX         5'b0_0101
`define  AND          5'd6
`define  OR           5'd7
`define  XOR		  5'd8
`define  EXTS		  5'd9
`define  EXTU         5'd10
`define  ROTATION_LEFT 5'd11
`define  ROTATION_RIGHT 5'd12
`define  ROTATION_X_LEFT 5'd13
`define  ROTATION_X_RIGHT 5'd14
`define  ARITHMATIC_SHIFT_LEFT 5'd15  
`define  ARITHMATIC_SHIFT_RIGHT 5'd16
`define  LOGIC_SHIFT_LEFT 5'd17
`define  LOGIC_SHIFT_RIGHT 5'd18
`define  BCLR			5'd19
`define  BSET			5'd20
`define  BNOT			5'd21
`define  BTST			5'd22
//`define  CMP			ALUƂĂSUB ɓ
`define  NEG			5'd23
`define  NOT			5'd24
`define   ADDS			5'd25
//`define   SUBS		ALUƂĂADDS ɓ


//CCR_SEL
//`define ALU_OUT_SEL  0
`define MOUT_31_24_SEL 1
`define MOUT_7_0_SEL   2

//imm_sel
`define IR3H_SEL_IMM 0
`define IR1H_SEL_IMM 1

//BCC
`define BRA 0
`define BRN 1
`define BHI 2
`define BLS 3
`define BHS 4
`define BLO 5
`define BNE 6
`define BEQ 7
`define BVC 8
`define BVS 9
`define BPL 10
`define BMI 11
`define BGE 12 
`define BLT 13
`define BGT 14
`define BLE 15

//ram_data_in
//`define ALU_OUT_SEL 0
`define PC_SEL_MEM 1


//bus state
`define RESET_STATE 1
`define NORMALSTATE 3
`define INT_STATE   2

//mul_div
`define MUL_DIV_WO_SIGN 0
`define MUL_DIV_W_SIGN 1
`define MUL_DIV_BYTE_ACCESS 0
`define MUL_DIV_WORD_ACCESS 1
`define MUL_DIV_MUL_SEL 0
`define MUL_DIV_DIV_SEL 1
