`timescale 1ns/1ps
module mul_div_test;
	reg clock=0,sync_reset=1;
	reg [31:0] a,b;
	reg [7:0] ST;
	reg mul_div_enable=1,mul_div_sign=1,mul_div_word=1,mul_div_mode=1;
//	wire stop_state;
	wire [31:0] mul_div_out,a_reg,b_reg;
	wire [15:0] answer_reg;
	wire finish_operation;
	wire end_state;
	
	
	reg dummy;
	
	always #10 clock=~clock;
	assign end_state=ST==8'b0000_1000;


// State Counter
        always @ (posedge clock) begin
                if (sync_reset ==1'b1)   ST<=8'h00;
                else if (end_state== 1'b1)    ST<=8'h00;
                else   begin
				if (stop_state) ST<=ST;
				else casex(ST)
						8'b0000_0000: ST<=8'b0000_0001;
						8'b????_???1: ST<=8'b0000_0010;
						8'b????_??1?: ST<=8'b0000_0100;
						8'b????_?1??: ST<=8'b0000_1000;
						8'b????_1???: ST<=8'b0001_0000;
						8'b???1_????: ST<=8'b0010_0000;
						8'b??1?_????: ST<=8'b0100_0000;
						8'b?1??_????: ST<=8'b1000_0000;
						8'b1???_????: ST<=8'b0000_0000;
					endcase
		    end                       
        end
	always @(posedge Clock) begin
			dummy=0;
	
	end

	initial begin
		
	
		a=20;
		b=1;
		#205 sync_reset=0;
	
		
		


		@( posedge end_state);
		a=20;
		b=3;
		
		@( posedge end_state);
		a=20;
		b=20;
		@(posedge end_state);
		a=20;
		b=7;

		@(posedge end_state);
		a=20;
		b=7;

		#1000;
		$finish;





	end


 mul_div mul_div1(.clock(clock),.sync_reset(sync_reset),.a(a)
	,.b(b),.mul_div_out(mul_div_out),.mul_div_sign(mul_div_sign),.mul_div_word(mul_div_word),
	.mul_div_mode(mul_div_mode),.state(ST),.stop_state(stop_state),.mul_div_enable(mul_div_enable)
	);
	








endmodule