//Jun.2.2004
// mul/div ZW[
// mul /ȂB 8x8        1clock   (CPU߂ƂĂ͂SClock,Fetch,Decode,Execute,Writej 
//				        16x16     1clock   (CPU߂ƂĂ͂SClockj 
// div 				  16/8      8 clock  (CPU߂ƂẮAPQCLOCKj
//					  32/16    16 clock (CPU߂ƂẮAQOCLOCK)
//
// a[31:0] /b[15:0]  =>  
//   mul_div_out[15:0]  <=a/b
//   mul_div_out[31:16] <=a%b
// I[ot[̌oȂB
// Z̃ASY
//  answer_reg = (answer_reg << 1);
//    if (a_reg >= b_reg) {
//       answer_reg += 1;
//       a_reg -= b_reg;
//    }
//    b_reg = b_reg >> 1;
`include "define.h"
module mul_div(clock,sync_reset,a,b,mul_div_out,mul_div_sign,mul_div_word,mul_div_mode,state,stop_state,mul_div_enable);
	input clock,sync_reset;
	input [31:0] a,b;
	input [7:0] state;
	input mul_div_enable,mul_div_sign,mul_div_word,mul_div_mode;
	output stop_state;
	output [31:0] mul_div_out;

	reg [31:0] a_reg;
	reg [31:0] b_reg;
	reg [15:0] answer_reg;
	reg stop_state_reg;// For state control
	reg [4:0] counter;
	reg mul_div_sign_ff,mul_div_word_ff,mul_div_mode_ff;

	wire finish_operation;
	wire pre_stop;
	wire [32:0] sum;
	wire [15:0] answer_inc;
	wire [31:0] aminus=-a;
	
	wire  [31:0] p1,p2,p3,p4;
	wire [15:0] p1b,p2b,p3b,p4b;

	wire [31:0] mul_out32;
	wire [15:0] mul_out16;
	wire [31:0] mul_func;
	wire [14:0] temp_p2,temp_p3;		
//mul function
	assign p1={1'b0,a_reg[15] & b_reg[15],30'h00_0000_00};
//	assign p2={1'b0,{15{a_reg[15]}} & b_reg[14:0],16'h0000};
//	assign p3={1'b0,{15{b_reg[15]}} & a_reg[14:0],16'h0000};
	assign temp_p2={{15{a_reg[15]}} & b_reg[14:0]};
	assign temp_p3={{15{b_reg[15]}} & a_reg[14:0]};
	assign p2={2'b00,temp_p2,15'h0000};
	assign p3={2'b00,temp_p3,15'h0000};
	assign p4=a_reg[14:0] *b_reg[14:0];

	assign mul_out32=p4;//mul_div_sign_ff ? p1-p2-p3+p4 : p1+p2+p3+p4;
	
	assign p1b={1'b0,a_reg[7] & b_reg[7],14'h0000};
	assign p2b={2'b0,{7{a_reg[7]}} & b_reg[6:0],7'h00};
	assign p3b={2'b0,{7{b_reg[7]}} & a_reg[6:0],7'h00};
	assign p4b=a_reg[6:0] *b_reg[6:0];

	assign mul_out16=p4b;//mul_div_sign_ff ? p1b-p2b-p3b+p4b : p1b+p2b+p3b+p4b;
	assign mul_func=mul_div_word_ff ==`MUL_DIV_WORD_ACCESS  ? mul_out32 : {16'h0000,mul_out16};	
 	assign mul_div_out=mul_div_mode_ff==`MUL_DIV_MUL_SEL ? mul_func : { a_reg[15:0] ,answer_reg};	


//input FFs
	always @(posedge clock) begin
		if (sync_reset) begin
			mul_div_sign_ff<=0;
			mul_div_word_ff<=0;
			mul_div_mode_ff<=0;


		end else if (pre_stop) begin
			mul_div_sign_ff<=mul_div_sign;
			mul_div_word_ff<=mul_div_word;
			mul_div_mode_ff<=mul_div_mode;
		end
	end

//state_machine
	assign pre_stop=mul_div_enable && state==8'b0000_0001;
	assign finish_operation=counter==17 && (mul_div_word_ff ==`MUL_DIV_WORD_ACCESS) ||
					 	  counter==9 &&  (mul_div_word_ff ==`MUL_DIV_BYTE_ACCESS);
			

	always @(posedge clock) begin
		if (sync_reset) stop_state_reg <=0;
		else if (pre_stop && !stop_state_reg && mul_div_mode !=`MUL_DIV_MUL_SEL)  stop_state_reg<=1;
		else if (stop_state_reg && finish_operation) stop_state_reg<=0;  

	end

	assign stop_state=mul_div_enable && mul_div_mode !=`MUL_DIV_MUL_SEL && (  stop_state_reg);

	always @(posedge clock) begin
		if (sync_reset) counter <=0;
		else if (!stop_state_reg) counter <=0;
		else if (stop_state_reg ) counter <=counter+1;
	end

//a_reg
	always @(posedge clock) begin
		if(mul_div_mode==`MUL_DIV_MUL_SEL && pre_stop)  a_reg <=a;//|ZȂ烉b`邾
	      else begin//犄Z
			if (!stop_state_reg ) a_reg <=a_reg;//OperationIĂȂێ
 			else if (counter==0 ) begin //ŏ́A
				if (mul_div_sign_ff) begin//tȂ
					if (mul_div_word_ff ==`MUL_DIV_WORD_ACCESS && a[31])       a_reg <=aminus;//Ȃ琳ɂ
				      else  if (mul_div_word_ff ==`MUL_DIV_BYTE_ACCESS && a[15]) a_reg <=aminus ;//[15:0]  <=aminus[15:0]; //Ȃ琳ɂ
					else a_reg <=a;
				end else  a_reg <=a;//ȂȂ炻̂܂܃b`
			end else begin//div s
				if (mul_div_word_ff ==`MUL_DIV_WORD_ACCESS && !sum[32]) begin//if (a_reg >=b_reg)
					if ( finish_operation && mul_div_sign_ff && a[31]  ) a_reg <=-sum;//Ō͔񏜐ɂ킹
					else a_reg <=sum;//sum[15:0];// a_reg -= b_reg
				end else if (mul_div_word_ff ==`MUL_DIV_BYTE_ACCESS && !sum[16]) begin//if (a_reg >=b_reg)
					if ( finish_operation && mul_div_sign_ff && a[15]  ) a_reg <=-sum;//Ō͔񏜐ɂ킹
					else a_reg <=sum;//sum[7:0];// a_reg -=b_reg
				end else begin
					if         ( finish_operation && mul_div_word_ff ==`MUL_DIV_WORD_ACCESS && mul_div_sign_ff && a[31]  ) a_reg <=-a_reg;//Ō͔񏜐ɂ킹
					else  if  (finish_operation &&mul_div_word_ff  !=`MUL_DIV_WORD_ACCESS   && mul_div_sign_ff && a[15]   ) a_reg <=-a_reg; //Ō͔񏜐ɂ킹 
					else a_reg <=a_reg;
				end
			end
		end
	 end

//b_reg
	always @(posedge clock) begin
		if(mul_div_mode==`MUL_DIV_MUL_SEL && pre_stop)  b_reg <={16'h0000,b[15:0]};//|ZȂ烉b`邾
	      else begin//犄Z
			if (!stop_state_reg ) b_reg <=b_reg;//OperationIĂȂێ
 			else if (counter==0 ) begin //ŏ́A
				if (mul_div_sign_ff) begin//tȂ
					if (mul_div_word_ff ==`MUL_DIV_WORD_ACCESS && b[15])  b_reg <={-b[15:0],16'h0000};//Ȃ琳ɂČ킹
				      else  if (mul_div_word_ff ==`MUL_DIV_BYTE_ACCESS && b[7]) b_reg <={16'h0000, -b[7:0],8'h00}; //Ȃ琳ɂČ킹
					else  if (mul_div_word_ff ==`MUL_DIV_WORD_ACCESS) b_reg <={b[15:0],16'h0000};//ȂȂ猅킹̂
					else  b_reg<= {16'h00,b[7:0],8'h00};//ȂȂ猅킹̂
				end else begin
					if (mul_div_word_ff ==`MUL_DIV_WORD_ACCESS) b_reg <={b[15:0],16'h0000};//ȂȂ猅킹̂
					else  b_reg<= {16'h00,b[7:0],8'h00};//ȂȂ猅킹̂
				end

			end else begin//div s
					 b_reg <={1'b0,b_reg[31:1]};// b_reg >>=1;
			end
		end
	 end

//answer_reg
	always @(posedge clock) begin
		if(mul_div_mode_ff==`MUL_DIV_MUL_SEL && pre_stop)  answer_reg <=0;//|ZȂ烉b`邾
	      else begin//犄Z
			if (!stop_state_reg ) answer_reg <=answer_reg;//OperationIĂȂێ
 			else if (counter==0 ) answer_reg<=0; //ŏ́A[NA
			else begin//div s
				if (mul_div_word_ff ==`MUL_DIV_WORD_ACCESS && !sum[32] ) begin//if (a_reg >=b_reg)
					 if (finish_operation && (a[31] ^ b[15])  &&  mul_div_sign_ff ) answer_reg <=-answer_inc;//ȂŌɔ]
					 else if (finish_operation) answer_reg <=answer_inc;
					 else answer_reg <={answer_inc[14:0],1'b0};   //Jun.7.2004  a_reg -= b_reg
				end else if (mul_div_word_ff ==`MUL_DIV_BYTE_ACCESS && !sum[16] ) begin//if (a_reg >=b_reg)
					 if (finish_operation && (a[15] ^ b[7] )  && mul_div_sign_ff) answer_reg <=0- answer_inc;//ȂŌɔ]
					 else if (finish_operation) answer_reg <=answer_inc;
					 else answer_reg <={answer_inc[14:0],1'b0};//Jun.7.2004 
				end else begin
					 if  (finish_operation ) begin
						 if ( (a[31] ^ b[15])  &&  mul_div_sign_ff  && mul_div_word_ff ==`MUL_DIV_WORD_ACCESS) //ȂŌɔ]
							  answer_reg <=0-answer_reg;
						 else if (	 (a[15] ^ b[7] )  && mul_div_sign_ff && mul_div_word_ff !=`MUL_DIV_WORD_ACCESS)//ȂŌɔ]			
							  answer_reg <=0-answer_reg;
						 else answer_reg <=answer_reg;
					 end else answer_reg <={answer_reg[14:0],1'b0};   // answer_reg <<=1;
				end
			end
		end
	 end

//	assign sum=a_reg-b_reg;//sum carry 
	assign sum={1'b0,a_reg}+~{1'b0,b_reg}+1'b1;//Jun.8.2004 Stratix2 bug??sum carry 

      assign answer_inc=answer_reg+1'b1;//Jun.7.2004


	

endmodule

